/**
 * Legacy code. Should avoid to use if you are new to import these code.
 */
import React from 'react';
import { BasicDataNode, DataEntity, DataNode, Direction, FlattenNode, KeyEntities, NodeElement, NodeInstance, SafeKey } from './interface';
import { AllowDrop, TreeProps } from './Tree';
export { getPosition, isTreeNode } from './utils/treeUtil';
export declare function arrDel(list: SafeKey[], value: SafeKey): SafeKey[];
export declare function arrAdd(list: SafeKey[], value: SafeKey): SafeKey[];
export declare function posToArr(pos: string): string[];
export declare function getDragChildrenKeys<TreeDataType extends BasicDataNode = DataNode>(dragNodeKey: SafeKey, keyEntities: KeyEntities<TreeDataType>): SafeKey[];
export declare function isLastChild<TreeDataType extends BasicDataNode = DataNode>(treeNodeEntity: DataEntity<TreeDataType>): boolean;
export declare function isFirstChild<TreeDataType extends BasicDataNode = DataNode>(treeNodeEntity: DataEntity<TreeDataType>): boolean;
export declare function calcDropPosition<TreeDataType extends BasicDataNode = DataNode>(event: React.MouseEvent, dragNode: NodeInstance<TreeDataType>, targetNode: NodeInstance<TreeDataType>, indent: number, startMousePosition: {
    x: number;
    y: number;
}, allowDrop: AllowDrop<TreeDataType>, flattenedNodes: FlattenNode<TreeDataType>[], keyEntities: KeyEntities<TreeDataType>, expandKeys: SafeKey[], direction: Direction): {
    dropPosition: -1 | 0 | 1;
    dropLevelOffset: number;
    dropTargetKey: SafeKey;
    dropTargetPos: string;
    dropContainerKey: SafeKey;
    dragOverNodeKey: SafeKey;
    dropAllowed: boolean;
};
/**
 * Return selectedKeys according with multiple prop
 * @param selectedKeys
 * @param props
 * @returns [string]
 */
export declare function calcSelectedKeys(selectedKeys: SafeKey[], props: TreeProps): SafeKey[];
export declare function convertDataToTree(treeData: DataNode[], processor?: {
    processProps: (prop: DataNode) => any;
}): NodeElement[];
/**
 * Parse `checkedKeys` to { checkedKeys, halfCheckedKeys } style
 */
export declare function parseCheckedKeys(keys: SafeKey[] | {
    checked: SafeKey[];
    halfChecked: SafeKey[];
}): any;
/**
 * If user use `autoExpandParent` we should get the list of parent node
 * @param keyList
 * @param keyEntities
 */
export declare function conductExpandParent(keyList: SafeKey[], keyEntities: KeyEntities): SafeKey[];
