import { BasicDataNode, DataNode, GetCheckDisabled, SafeKey, KeyEntities } from '../interface';
interface ConductReturnType {
    checkedKeys: SafeKey[];
    halfCheckedKeys: SafeKey[];
}
export declare function isCheckDisabled<TreeDataType>(node: TreeDataType): boolean;
/**
 * Conduct with keys.
 * @param keyList current key list
 * @param keyEntities key - dataEntity map
 * @param mode `fill` to fill missing key, `clean` to remove useless key
 */
export declare function conductCheck<TreeDataType extends BasicDataNode = DataNode>(keyList: SafeKey[], checked: true | {
    checked: false;
    halfCheckedKeys: SafeKey[];
}, keyEntities: KeyEntities<TreeDataType>, getCheckDisabled?: GetCheckDisabled<TreeDataType>): ConductReturnType;
export {};
